[LEDE-DEV] [PATCH] ugps: fix and improve init script

Piotr Dymacz pepe2k at gmail.com
Sun Mar 5 12:09:16 PST 2017


The ugps tool expects device path in last argument. If it's provided
before other options, they won't be processed at all.

Additionally, make it possible to use absolute path for gps character
device in related uci configuration.

Signed-off-by: Piotr Dymacz <pepe2k at gmail.com>
---
 package/utils/ugps/Makefile        | 2 +-
 package/utils/ugps/files/ugps.init | 8 ++++++--
 2 files changed, 7 insertions(+), 3 deletions(-)

diff --git a/package/utils/ugps/Makefile b/package/utils/ugps/Makefile
index 8744300..1dad863 100644
--- a/package/utils/ugps/Makefile
+++ b/package/utils/ugps/Makefile
@@ -8,7 +8,7 @@
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=ugps
-PKG_RELEASE:=2
+PKG_RELEASE:=3
 
 PKG_SOURCE_URL=$(LEDE_GIT)/project/ugps.git
 PKG_SOURCE_PROTO:=git
diff --git a/package/utils/ugps/files/ugps.init b/package/utils/ugps/files/ugps.init
index a7a88c2..157043c 100644
--- a/package/utils/ugps/files/ugps.init
+++ b/package/utils/ugps/files/ugps.init
@@ -14,11 +14,15 @@ start_service() {
 	local tty="$(uci get gps. at gps[-1].tty)"
 	local atime="$(uci get gps. at gps[-1].adjust_time)"
 
-	[ -d "/sys/class/tty/$tty/" ] || return
+	[ -c "$tty" ] || {
+		tty="/dev/$tty"
+		[ -c "$tty" ] || return
+	}
 
 	procd_open_instance
-	procd_set_param command "$PROG" "/dev/$tty"
+	procd_set_param command "$PROG"
 	[ "$atime" -eq 0 ] || procd_append_param command "-a"
+	procd_append_param command "$tty"
 	procd_set_param respawn
 	procd_close_instance
 }
-- 
2.7.4




More information about the Lede-dev mailing list